import type { Provider } from '@commerce'
import fetcher from './fetcher'

// TODO: Using dummy hooks to fetch static content. Based on the local framework.
import { handler as useCart } from './cart/use-cart'
import { handler as useAddItem } from './cart/use-add-item'
import { handler as useUpdateItem } from './cart/use-update-item'
import { handler as useRemoveItem } from './cart/use-remove-item'
import { handler as useCustomer } from './customer/use-customer'
import { handler as useSearch } from './product/use-search'
import { handler as useLogin } from './auth/use-login'
import { handler as useLogout } from './auth/use-logout'
import { handler as useSignup } from './auth/use-signup'

const provider = {
  locale: '', // Not an optional key in TypeScript, but already set in config. So, just make it an empty string.
  cartCookie: '', // Not an optional key in TypeScript, but already set in config. So, just make it an empty string.
  fetcher,
  // FIXME: Add dummy hooks for below based on framework/local EXCEPT use-product
  cart: { useCart, useAddItem, useUpdateItem, useRemoveItem },
  customer: { useCustomer },
  products: { useSearch },
  auth: { useLogin, useLogout, useSignup },
}

export { provider }

export type { Provider }
